diff --git a/src/detection-plugins/sp_sctp_chunk_field.c b/src/detection-plugins/sp_sctp_chunk_field.c
new file mode 100644
index 0000000..bbc99cb
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_field.c
@@ -0,0 +1,635 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <sys/types.h>
+#include <stdlib.h>
+#include <ctype.h>
+
+#include "sf_types.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "decode.h"
+#include "plugbase.h"
+#include "parser.h"
+#include "util.h"
+#include "snort_debug.h"
+#include "plugin_enum.h"
+#include "sp_sctp_chunk_field.h"
+
+#include "snort.h"
+#include "profiler.h"
+#ifdef PERF_PROFILING
+PreprocStats sctpChunkFieldPerfStats;
+extern PreprocStats ruleOTNEvalPerfStats;
+#endif
+
+#include "sfhashfcn.h"
+#include "detection_options.h"
+
+
+/**
+ * SctpChunkFieldHash - Hash function for sctp_chunk_field.
+ * @data: pointer to SctpChunkFieldData.
+ *
+ * Returns a uint32_t representing the hash.
+ */
+uint32_t SctpChunkFieldHash(void *data)
+{
+    uint32_t a, b, c;
+    SctpChunkFieldData *scfd = (SctpChunkFieldData *)data;
+
+    a = scfd->field;
+    b = scfd->operator;
+    c = scfd->value_min;
+    mix(a, b, c);
+    a += scfd->value_max;
+    b += RULE_OPTION_TYPE_SCTP_CHUNK_FIELD;
+    final(a, b, c);
+
+    return c;
+}
+
+/**
+ * SctpChunkFieldCompare - Comparator function for sctp_chunk_field.
+ * @l: pointer to SctpChunkFieldData (left side).
+ * @r: pointer to SctpChunkFieldData (right side).
+ *
+ * Returns the comparison result of the two data structures.
+ */
+int SctpChunkFieldCompare(void *l, void *r)
+{
+    SctpChunkFieldData *left = (SctpChunkFieldData *)l;
+    SctpChunkFieldData *right = (SctpChunkFieldData *)r;
+
+    if (!left)
+        return (!right ? DETECTION_OPTION_EQUAL : 
+                         DETECTION_OPTION_NOT_EQUAL);
+    
+    if (!right)
+        return (!left ? DETECTION_OPTION_EQUAL : 
+                        DETECTION_OPTION_NOT_EQUAL);
+
+    if (left->field != right->field)         return DETECTION_OPTION_NOT_EQUAL;
+    if (left->operator != right->operator)   return DETECTION_OPTION_NOT_EQUAL;
+    if (left->value_min != right->value_min) return DETECTION_OPTION_NOT_EQUAL;
+    if (left->value_max != right->value_max) return DETECTION_OPTION_NOT_EQUAL;
+
+    return DETECTION_OPTION_EQUAL;
+}
+
+/**
+ * SctpChunkFieldSetup - Setup function for sctp_chunk_field.
+ *
+ * Links the 'sctp_chunk_field' keyword to its initialization function.
+ * Returns void.
+ */
+void SctpChunkFieldSetup(void)
+{
+    /* Map the keyword to an initialization/processing function */
+    RegisterRuleOption("sctp_chunk_field", SctpChunkFieldInit, NULL, OPT_TYPE_DETECTION, NULL);
+    
+#ifdef PERF_PROFILING
+    RegisterPreprocessorProfile("sctp_chunk_field", &sctpChunkFieldPerfStats, 3, &ruleOTNEvalPerfStats);
+#endif
+
+    DEBUG_WRAP(DebugMessage(DEBUG_PLUGIN,"Plugin: SctpChunkField Initialized\n"););
+}
+
+/**
+ * SctpChunkFieldInit - Initialization function for sctp_chunk_field.
+ * @data: pointer to SctpChunkFieldData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ * @protocol: integer value representing the transport-layer protocol.
+ *
+ * Attaches the rule option data to the appropriate data structure and links
+ * in the evaluator function to the function pointer list.  Returns void.
+ */
+void SctpChunkFieldInit(char *data, OptTreeNode *otn, int protocol)
+{
+    OptFpList *fpl;
+    SctpChunkFieldData *scfd;
+    void *scfd_dup;
+
+    /* This keyword only applies to the SCTP Protocol. */
+    if (protocol != IPPROTO_SCTP)
+        FatalError("Error at %s:%d: 'sctp_chunk_field' can only be used with "
+                   "the SCTP protocol.\n", file_name, file_line);
+
+    /* Allocate the data structure and attach it to the otn->ds_list. */
+    scfd = (SctpChunkFieldData *)SnortAlloc(sizeof(SctpChunkFieldData));
+
+    /* Parse the keyword's parameters and configure the data structure. */
+    SctpChunkFieldParse(data, scfd, otn);
+
+    /* Check for a duplicate entry in the otn. */
+    if (add_detection_option(RULE_OPTION_TYPE_SCTP_CHUNK_FIELD,
+                             (void *)scfd, &scfd_dup) == DETECTION_OPTION_EQUAL)
+    {
+        free(scfd);
+        scfd = (SctpChunkFieldData *)scfd_dup;
+    }
+
+    /*
+     * Finally, attach the option's detection function to the rule's detection
+     * function pointer list
+     */
+    fpl = AddOptFuncToList(SctpChunkFieldEval, otn);
+    fpl->type = RULE_OPTION_TYPE_SCTP_CHUNK_FIELD;
+    fpl->context = (void *)scfd;
+}
+
+/**
+ * SctpChunkFieldParse - Parsing function for sctp_chunk_field.
+ * @data: pointer to SctpChunkFieldData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ *
+ * Parses the rule option's parameter list and fills in the SctpChunkFieldData
+ * structure.  Returns void.
+ */
+void SctpChunkFieldParse(char *data, SctpChunkFieldData *scfd, OptTreeNode *otn)
+{
+    char *str, *strtmp, *tok, *end;
+    char *chunk, *field;
+    uint32_t parse_status = SCTP_CHUNK_FIELD_PARSE_NONE;
+
+    /* Covert to a string and make a copy of the pointer. */
+    str = SnortStrdup(data);
+    strtmp = str;
+
+    /* Skip any leading whitespace. */
+    while(isspace((int)*strtmp)) strtmp++;
+
+    /* Parse. */
+    tok = strtok(strtmp, ",");
+    while (tok)
+    {
+        /* Continue to skip any whitespace. */
+        while(isspace((int)*tok)) tok++;
+
+        /* Parse the first field, which should be the chunk type. */
+        if (parse_status == SCTP_CHUNK_FIELD_PARSE_NONE)
+        {
+            /*
+             * Parse the first operand: the chunk type.  This is left-shifted
+             * by 8 to store it in the upper-half of the scfd->field variable.
+             * The lower 8 bits will be used for storing the particular field
+             * ID that we wish to check.
+             */
+            if      (!strcasecmp("DATA", tok))              scfd->field = (SCTP_DATA_C << 8);
+            else if (!strcasecmp("INIT", tok))              scfd->field = (SCTP_INIT_C << 8);
+            else if (!strcasecmp("INIT-ACK", tok))          scfd->field = (SCTP_INIT_ACK_C << 8);
+            else if (!strcasecmp("SACK", tok))              scfd->field = (SCTP_SACK_C << 8);
+            else if (!strcasecmp("HEARTBEAT", tok))         scfd->field = (SCTP_HEARTBEAT_C << 8);
+            else if (!strcasecmp("HEARTBEAT-ACK", tok))     scfd->field = (SCTP_HEARTBEAT_ACK_C << 8);
+            else if (!strcasecmp("ABORT", tok))             scfd->field = (SCTP_ABORT_C << 8);
+            else if (!strcasecmp("SHUTDOWN", tok))          scfd->field = (SCTP_SHUTDOWN_C << 8);
+            else if (!strcasecmp("SHUTDOWN-ACK", tok))      scfd->field = (SCTP_SHUTDOWN_ACK_C << 8);
+            else if (!strcasecmp("ERROR", tok))             scfd->field = (SCTP_ERROR_C << 8);
+            else if (!strcasecmp("COOKIE-ECHO", tok))       scfd->field = (SCTP_COOKIE_ECHO_C << 8);
+            else if (!strcasecmp("COOKIE-ACK", tok))        scfd->field = (SCTP_COOKIE_ACK_C << 8);
+            else if (!strcasecmp("ECNE", tok))              scfd->field = (SCTP_ECNE_C << 8);
+            else if (!strcasecmp("CWR", tok))               scfd->field = (SCTP_CWR_C << 8);
+            else if (!strcasecmp("SHUTDOWN-COMPLETE", tok)) scfd->field = (SCTP_SHUTDOWN_COMPLETE_C << 8);
+            else if (!strcasecmp("AUTH", tok))              scfd->field = (SCTP_AUTH_C << 8);
+            else if (!strcasecmp("ASCONF-ACK", tok))        scfd->field = (SCTP_ASCONF_ACK_C << 8);
+            else if (!strcasecmp("PKTDROP", tok))           scfd->field = (SCTP_PKTDROP_C << 8);
+            else if (!strcasecmp("RE-CONFIG", tok))         scfd->field = (SCTP_RECONFIG_C << 8);
+            else if (!strcasecmp("PAD", tok))               scfd->field = (SCTP_PAD_C << 8);
+            else if (!strcasecmp("FORWARD-TSN", tok))       scfd->field = (SCTP_FORWARD_TSN_C << 8);
+            else if (!strcasecmp("ASCONF", tok))            scfd->field = (SCTP_ASCONF_C << 8);
+            else
+                FatalError("Error at %s:%d: %s is not a recognized argument to "
+                           "'sctp_chunk_field'.\n", file_name, file_line, tok);
+
+            /*
+             * Now check the scfd->field value for chunks that don't have any
+             * numeric fields to check (yet).  We do it this way because one day,
+             * they may get a numeric field of some kind.
+             */
+            switch (scfd->field >> 8)
+            {
+                case SCTP_HEARTBEAT_C:
+                case SCTP_HEARTBEAT_ACK_C:
+                case SCTP_ABORT_C:
+                case SCTP_SHUTDOWN_ACK_C:
+                case SCTP_ERROR_C:
+                case SCTP_COOKIE_ECHO_C:
+                case SCTP_COOKIE_ACK_C:
+                case SCTP_SHUTDOWN_COMPLETE_C:
+                case SCTP_RECONFIG_C:
+                case SCTP_PAD_C:
+                    FatalError("Error at %s:%d: %s does not have any numeric "
+                               "fields to check for.", file_name, file_line, tok);
+                    break;
+            }
+            
+            parse_status = SCTP_CHUNK_FIELD_PARSE_TYPE;
+            chunk = tok;
+            tok = strtok(NULL, ",");
+        }
+        
+        /*
+         * If the type is parsed, move on to parse the particular field to
+         * check in the selected chunk type.
+         */
+        else if (parse_status == SCTP_CHUNK_FIELD_PARSE_TYPE)
+        {
+            switch (scfd->field >> 8)
+            {
+                case SCTP_DATA_C:
+                    if      (!strcasecmp("tsn", tok))             scfd->field += SCTP_DATA_TSN;
+                    else if (!strcasecmp("stream_id", tok))       scfd->field += SCTP_DATA_STREAM_ID;
+                    else if (!strcasecmp("stream_seq", tok))      scfd->field += SCTP_DATA_STREAM_SEQ;
+                    else if (!strcasecmp("payload_id", tok))      scfd->field += SCTP_DATA_PAYLOAD_ID;
+                    else goto field_error;
+                    break;
+
+                case SCTP_INIT_C:
+                    if      (!strcasecmp("initiate_tag", tok))    scfd->field += SCTP_INIT_INITIATE_TAG;
+                    else if (!strcasecmp("a_rwnd", tok))          scfd->field += SCTP_INIT_A_RWND;
+                    else if (!strcasecmp("num_out_streams", tok)) scfd->field += SCTP_INIT_NUM_OUT_STRMS;
+                    else if (!strcasecmp("num_in_streams", tok))  scfd->field += SCTP_INIT_NUM_IN_STRMS;
+                    else if (!strcasecmp("tsn", tok))             scfd->field += SCTP_INIT_TSN;
+                    else goto field_error;
+                    break;
+
+                case SCTP_INIT_ACK_C:
+                    if      (!strcasecmp("initiate_tag", tok))    scfd->field += SCTP_INIT_ACK_INITIATE_TAG;
+                    else if (!strcasecmp("a_rwnd", tok))          scfd->field += SCTP_INIT_ACK_A_RWND;
+                    else if (!strcasecmp("num_out_streams", tok)) scfd->field += SCTP_INIT_ACK_NUM_OUT_STRMS;
+                    else if (!strcasecmp("num_in_streams", tok))  scfd->field += SCTP_INIT_ACK_NUM_IN_STRMS;
+                    else if (!strcasecmp("tsn", tok))             scfd->field += SCTP_INIT_ACK_TSN;
+                    else goto field_error;
+                    break;
+
+                case SCTP_SACK_C:
+                    if      (!strcasecmp("cuml_tsn_ack", tok))    scfd->field += SCTP_SACK_CUML_TSN_ACK;
+                    else if (!strcasecmp("a_rwnd", tok))          scfd->field += SCTP_SACK_A_RWND;
+                    else if (!strcasecmp("num_gap_acks", tok))    scfd->field += SCTP_SACK_NUM_GAP_ACKS;
+                    else if (!strcasecmp("num_dupe_tsns", tok))   scfd->field += SCTP_SACK_NUM_DUPE_TSNS;
+                    else goto field_error;
+                    break;
+
+                case SCTP_SHUTDOWN_C:
+                    if      (!strcasecmp("tsn_ack", tok))         scfd->field += SCTP_SHUTDOWN_TSN_ACK;
+                    else goto field_error;
+                    break;
+
+                case SCTP_ECNE_C:
+                    if      (!strcasecmp("lowest_tsn", tok))      scfd->field += SCTP_ECNE_LOWEST_TSN;
+                    else goto field_error;
+                    break;
+
+                case SCTP_CWR_C:
+                    if      (!strcasecmp("lowest_tsn", tok))      scfd->field += SCTP_CWR_LOWEST_TSN;
+                    else goto field_error;
+                    break;
+
+                case SCTP_AUTH_C:
+                    if      (!strcasecmp("skey_id", tok))         scfd->field += SCTP_AUTH_SKEY_ID;
+                    else if (!strcasecmp("hmac_id", tok))         scfd->field += SCTP_AUTH_HMAC_ID;
+                    else goto field_error;
+                    break;
+
+                case SCTP_ASCONF_ACK_C:
+                    if      (!strcasecmp("seq", tok))             scfd->field += SCTP_ASCONF_ACK_SEQ;
+                    else goto field_error;
+                    break;
+
+                case SCTP_PKTDROP_C:
+                    if      (!strcasecmp("lbmr", tok))            scfd->field += SCTP_PKTDROP_LBMR;
+                    else if (!strcasecmp("queue_size", tok))      scfd->field += SCTP_PKTDROP_QUEUE_SIZE;
+                    else if (!strcasecmp("trunc_length", tok))    scfd->field += SCTP_PKTDROP_TRUNC_LENGTH;
+                    else if (!strcasecmp("reserved", tok))        scfd->field += SCTP_PKTDROP_RESERVED;
+                    else goto field_error;
+                    break;
+
+                case SCTP_FORWARD_TSN_C:
+                    if      (!strcasecmp("new_tsn", tok))         scfd->field += SCTP_FORWARD_TSN_NEW_TSN;
+                    else goto field_error;
+                    break;
+
+                case SCTP_ASCONF_C:
+                    if      (!strcasecmp("seq", tok))             scfd->field += SCTP_ASCONF_SEQ;
+                    else goto field_error;
+                    break;
+
+                default:
+                    FatalError("Error at %s:%d: Unknown chunk type 0x%2x or "
+                               "chunk does not have any numeric fields to "
+                               "check for.", file_name, file_line,
+                               (scfd->field >> 8));
+                    break;
+            }
+
+            parse_status = SCTP_CHUNK_FIELD_PARSE_FIELD;
+            field = tok;
+            tok = strtok(NULL, ",");
+        }
+
+        /*
+         * If the field is parsed, move on to parse the value.  The value can
+         * be a static value, or a ranged value (<, >, and <>).
+         */
+        else if (parse_status == SCTP_CHUNK_FIELD_PARSE_FIELD)
+        {
+            UNumericRange rng;
+            char *toktmp = tok;
+            uint32_t num = 0;
+            int rval = -3;
+
+            /* Parse out the operands of the range. */
+            rval = SnortStrToUNumRng(toktmp, "<>", &rng);
+            if (rval == SNORT_STR2RNG_SUCCESS)
+            {
+                scfd->value_min = rng.min;
+                scfd->value_max = rng.max;
+                scfd->operator = SCTP_CHUNK_FIELD_OP_RANGE;
+            }
+
+            /* Not a ranged value. */
+            else if (rval == SNORT_STR2RNG_NOTRNG)
+            {
+                if (*toktmp == '>')
+                {
+                    toktmp++;
+                    scfd->operator = SCTP_CHUNK_FIELD_OP_GT;
+                }
+                else if(*toktmp == '<')
+                {
+                    toktmp++;
+                    scfd->operator = SCTP_CHUNK_FIELD_OP_LT;
+                }
+                else
+                    scfd->operator = SCTP_CHUNK_FIELD_OP_EQUAL;
+            }
+
+            /* Error? */
+            else if (rval == SNORT_STR2RNG_ERROR)
+                goto value_error;
+
+            /* Parse the remainder and store it as the minimum value. */
+            if (scfd->operator != SCTP_CHUNK_FIELD_OP_RANGE)
+            {
+                num = strtoul(toktmp, &end, 10);
+                if (*end)
+                    goto value_error;
+
+                scfd->value_min = num;
+            }
+
+            parse_status = SCTP_CHUNK_FIELD_PARSE_VALUE;
+            tok = NULL;
+        }
+
+    }
+
+    return;
+
+field_error:
+    FatalError("Error %s:%d: The %s chunk does not have a field by the "
+                "name of %s!\n", file_name, file_line, chunk, tok);
+
+    return;
+    
+value_error:
+    FatalError("Error at %s:%d: Invalid value passed to "
+               "'sctp_chunk_field'!\n", file_name, file_line);
+
+    return;
+}
+
+/**
+ * SctpChunkFieldEval - Evaluation function for sctp_chunk_field.
+ * @data: pointer to SctpChunkFieldData (as char *).
+ * @p: pointer to Packet structure.
+ *
+ * Evaluates the rule option against the packet pointed to by 'p'.  Returns
+ * either DETECTION_OPTION_MATCH or DETECTION_OPTION_NO_MATCH.
+ */
+int SctpChunkFieldEval(void *data, Packet *p)
+{
+    SctpChunkFieldData *scfd = (SctpChunkFieldData *)data;
+    int rval = DETECTION_OPTION_NO_MATCH;
+    PROFILE_VARS;
+
+    if(!p->sctph || !scfd)
+        return rval;
+
+    PREPROC_PROFILE_START(sctpChunkFieldPerfStats);
+
+    SctpChunk *c = (SctpChunk *)p->sctph->chunks;
+    uint32_t remaining_len = p->dsize;
+    uint32_t chunk_type = (scfd->field >> 8);
+    uint32_t field = (scfd->field & 0x00ff);
+    uint32_t val = 0;
+
+    /*
+     * Loop through the chunks in the packet and for each chunk, check
+     * check the specified field against the supplied value(s) for a match.
+     */
+    while ((c != NULL) &&
+           (remaining_len != 0) &&
+           (rval == DETECTION_OPTION_NO_MATCH))
+    {
+        uint16_t chunk_length = SCTP_ADD_PADDING(ntohs(c->length));
+        remaining_len -= chunk_length;
+        
+        /*
+         * Continue the while loop if the chunk type in the packet does
+         * not match the chunk type selected by the rule keyword.
+         */
+        if (c->type != chunk_type)
+            goto next_chunk;
+
+        /* Fetch the specific field value from the specified chunk. */
+        switch (c->type)
+        {
+            case SCTP_DATA_C:
+                switch (field)
+                {
+                    case SCTP_DATA_TSN:               val = ntohl(c->data.tsn);                 break;
+                    case SCTP_DATA_STREAM_ID:         val = ntohs(c->data.stream_id);           break;
+                    case SCTP_DATA_STREAM_SEQ:        val = ntohs(c->data.stream_seq);          break;
+                    case SCTP_DATA_PAYLOAD_ID:        val = ntohl(c->data.payload_id);          break;
+                }
+                break;
+                
+            case SCTP_INIT_C:
+                switch (field)
+                {
+                    case SCTP_INIT_INITIATE_TAG:      val = ntohl(c->init.initiate_tag);        break;
+                    case SCTP_INIT_A_RWND:            val = ntohl(c->init.a_rwnd);              break;
+                    case SCTP_INIT_NUM_OUT_STRMS:     val = ntohs(c->init.num_out_streams);     break;
+                    case SCTP_INIT_NUM_IN_STRMS:      val = ntohs(c->init.num_in_streams);      break;
+                    case SCTP_INIT_TSN:               val = ntohl(c->init.tsn);                 break;
+                }
+                break;
+
+            case SCTP_INIT_ACK_C:
+                switch (field)
+                {
+                    case SCTP_INIT_ACK_INITIATE_TAG:  val = ntohl(c->init_ack.initiate_tag);    break;
+                    case SCTP_INIT_ACK_A_RWND:        val = ntohl(c->init_ack.a_rwnd);          break;
+                    case SCTP_INIT_ACK_NUM_OUT_STRMS: val = ntohs(c->init_ack.num_out_streams); break;
+                    case SCTP_INIT_ACK_NUM_IN_STRMS:  val = ntohs(c->init_ack.num_in_streams);  break;
+                    case SCTP_INIT_ACK_TSN:           val = ntohl(c->init_ack.tsn);             break;
+                }
+                break;
+
+            case SCTP_SACK_C:
+                switch (field)
+                {
+                    case SCTP_SACK_CUML_TSN_ACK:      val = ntohl(c->sack.cuml_tsn_ack);        break;
+                    case SCTP_SACK_A_RWND:            val = ntohl(c->sack.a_rwnd);              break;
+                    case SCTP_SACK_NUM_GAP_ACKS:      val = ntohs(c->sack.num_gap_acks);        break;
+                    case SCTP_SACK_NUM_DUPE_TSNS:     val = ntohs(c->sack.num_dupe_tsns);       break;
+                }
+                break;
+            
+            case SCTP_SHUTDOWN_C:
+                switch (field)
+                {
+                    case SCTP_SHUTDOWN_TSN_ACK:       val = ntohl(c->shutdown.tsn_ack);         break;
+                }
+                break;
+
+            case SCTP_ECNE_C:
+                switch(field)
+                {
+                    case SCTP_ECNE_LOWEST_TSN:        val = ntohl(c->ecne.lowest_tsn);          break;
+                }
+                break;
+
+            case SCTP_CWR_C:
+                switch (field)
+                {
+                    case SCTP_CWR_LOWEST_TSN:         val = ntohl(c->cwr.lowest_tsn);           break;
+                }
+                break;
+
+            case SCTP_AUTH_C:
+                switch (field)
+                {
+                    case SCTP_AUTH_SKEY_ID:           val = ntohs(c->auth.skey_id);             break;
+                    case SCTP_AUTH_HMAC_ID:           val = ntohs(c->auth.skey_id);             break;
+                }
+                break;
+
+            case SCTP_ASCONF_ACK_C:
+                switch (field)
+                {
+                    case SCTP_ASCONF_ACK_SEQ:         val = ntohl(c->asconf_ack.seq);           break;
+                }
+                break;
+
+            case SCTP_PKTDROP_C:
+                switch (field)
+                {
+                    case SCTP_PKTDROP_LBMR:           ntohl(val = c->pktdrop.lbmr);             break;
+                    case SCTP_PKTDROP_QUEUE_SIZE:     ntohl(val = c->pktdrop.queue_size);       break;
+                    case SCTP_PKTDROP_TRUNC_LENGTH:   ntohs(val = c->pktdrop.trunc_length);     break;
+                    case SCTP_PKTDROP_RESERVED:       ntohs(val = c->pktdrop.reserved);         break;
+                }
+                break;
+
+            case SCTP_FORWARD_TSN_C:
+                switch (field)
+                {
+                    case SCTP_FORWARD_TSN_NEW_TSN:    val = ntohl(c->forward_tsn.new_tsn);      break;
+                }
+                break;
+
+            case SCTP_ASCONF_C:
+                switch (field)
+                {
+                    case SCTP_ASCONF_SEQ:             val = ntohl(c->asconf.seq);               break;
+                }
+                break;
+
+            case SCTP_HEARTBEAT_C:
+            case SCTP_HEARTBEAT_ACK_C:
+            case SCTP_ABORT_C:
+            case SCTP_SHUTDOWN_ACK_C:
+            case SCTP_ERROR_C:
+            case SCTP_COOKIE_ECHO_C:
+            case SCTP_COOKIE_ACK_C:
+            case SCTP_SHUTDOWN_COMPLETE_C:
+            case SCTP_RECONFIG_C:
+            case SCTP_PAD_C:
+                DEBUG_WRAP(DebugMessage(
+                    DEBUG_PLUGIN, "Plugin (sctp_chunk_field): Chunk Type 0x%2x "
+                                  "does not have any numeric fields to compare "
+                                  "against.\n", c->type));
+                break;
+
+            default:
+                DEBUG_WRAP(DebugMessage(
+                    DEBUG_PLUGIN, "Plugin (sctp_chunk_field): Encountered "
+                                  "an unknown SCTP Chunk Type 0x%2x!\n",
+                                  c->type));
+                break;
+        }
+
+        /*
+         * Now compare the value from the field against the user-specified
+         * value, based on the set operator.
+         */
+        switch (scfd->operator)
+        {
+            case SCTP_CHUNK_FIELD_OP_EQUAL:
+                if (scfd->value_min == val)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_CHUNK_FIELD_OP_LT:
+                if (scfd->value_min > val)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_CHUNK_FIELD_OP_GT:
+                if (scfd->value_min < val)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_CHUNK_FIELD_OP_RANGE:
+                if ((scfd->value_min <= val) &&
+                    (scfd->value_max >= val))
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            default:
+                break;
+        }
+        break;
+
+next_chunk:
+        remaining_len = SctpGetNextChunk(c, remaining_len, chunk_length);
+    }
+
+    /* If the test isn't successful, return DETECTION_OPTION_NO_MATCH */
+    PREPROC_PROFILE_END(sctpChunkFieldPerfStats);
+    return rval;
+}
diff --git a/src/detection-plugins/sp_sctp_chunk_field.h b/src/detection-plugins/sp_sctp_chunk_field.h
new file mode 100644
index 0000000..70c01b9
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_field.h
@@ -0,0 +1,121 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+#ifndef __SP_SCTP_CHUNK_FIELD_H__
+#define __SP_SCTP_CHUNK_FIELD_H__
+
+/* These are used to know what phase of the parsing that we are on. */
+#define SCTP_CHUNK_FIELD_PARSE_NONE         0x00
+#define SCTP_CHUNK_FIELD_PARSE_TYPE         0x01
+#define SCTP_CHUNK_FIELD_PARSE_FIELD        0x02
+#define SCTP_CHUNK_FIELD_PARSE_VALUE        0x03
+
+/* Operator definitions for sctp_payload_id. */
+#define SCTP_CHUNK_FIELD_OP_EQUAL           0x01
+#define SCTP_CHUNK_FIELD_OP_LT              0x02
+#define SCTP_CHUNK_FIELD_OP_GT              0x03
+#define SCTP_CHUNK_FIELD_OP_RANGE           0x04
+
+/* Field definitions for DATA. */
+#define SCTP_DATA_TSN                       0x01
+#define SCTP_DATA_STREAM_ID                 0x02
+#define SCTP_DATA_STREAM_SEQ                0x03
+#define SCTP_DATA_PAYLOAD_ID                0x04
+
+/* Field definitions for INIT. */
+#define SCTP_INIT_INITIATE_TAG              0x01
+#define SCTP_INIT_A_RWND                    0x02
+#define SCTP_INIT_NUM_OUT_STRMS             0x03
+#define SCTP_INIT_NUM_IN_STRMS              0x04
+#define SCTP_INIT_TSN                       0x05
+
+/* Field definitions for INIT-ACK. */
+#define SCTP_INIT_ACK_INITIATE_TAG          0x01
+#define SCTP_INIT_ACK_A_RWND                0x02
+#define SCTP_INIT_ACK_NUM_OUT_STRMS         0x03
+#define SCTP_INIT_ACK_NUM_IN_STRMS          0x04
+#define SCTP_INIT_ACK_TSN                   0x05
+
+/* Field definitions for SACK. */
+#define SCTP_SACK_CUML_TSN_ACK              0x01
+#define SCTP_SACK_A_RWND                    0x02
+#define SCTP_SACK_NUM_GAP_ACKS              0x03
+#define SCTP_SACK_NUM_DUPE_TSNS             0x04
+
+/* No field definitions for HEARTBEAT. */
+/* No field definitions for HEARTBEAT-ACK. */
+/* No field definitions for ABORT. */
+
+/* Field definitions for SHUTDOWN. */
+#define SCTP_SHUTDOWN_TSN_ACK               0x01
+
+/* No field definitions for SHUTDOWN-ACK. */
+/* No field definitions for ERROR. */
+/* No field definitions for COOKIE-ECHO. */
+/* No field definitions for COOKIE-ACK. */
+
+/* Field definitions for ECNE. */
+#define SCTP_ECNE_LOWEST_TSN                0x01
+
+/* Field definitions for CWR. */
+#define SCTP_CWR_LOWEST_TSN                 0x01
+
+/* No field definitions for SHUTDOWN-COMPLETE. */
+
+/* Field definitions for AUTH. */
+#define SCTP_AUTH_SKEY_ID                   0x01
+#define SCTP_AUTH_HMAC_ID                   0x02
+
+/* Field definitions for ASCONF-ACK. */
+#define SCTP_ASCONF_ACK_SEQ                 0x01
+
+/* Field definitions for PKTDROP. */
+#define SCTP_PKTDROP_LBMR                   0x01
+#define SCTP_PKTDROP_QUEUE_SIZE             0x02
+#define SCTP_PKTDROP_TRUNC_LENGTH           0x03
+#define SCTP_PKTDROP_RESERVED               0x04
+
+/* No field definitions for RE-CONFIG. */
+/* No field definitions for PAD. */
+
+/* Field definitions for FORWARD-TSN. */
+#define SCTP_FORWARD_TSN_NEW_TSN            0x01
+
+/* Field definitions for ASCONF. */
+#define SCTP_ASCONF_SEQ                     0x01
+
+/* SctpChunkField data structure. */
+typedef struct _SctpChunkFieldData
+{
+    uint16_t field;
+    uint8_t operator;
+    uint32_t value_min;
+    uint32_t value_max;
+} SctpChunkFieldData;
+
+/* Prototypes. */
+uint32_t SctpChunkFieldHash(void *data);
+int SctpChunkFieldCompare(void *l, void *r);
+void SctpChunkFieldSetup(void);
+void SctpChunkFieldInit(char *data, OptTreeNode *otn, int protocol);
+void SctpChunkFieldParse(char *data, SctpChunkFieldData *scfd, OptTreeNode *otn);
+int SctpChunkFieldEval(void *data, Packet *p);
+
+#endif  /* __SP_SCTP_CHUNK_FIELD_H__ */
